#!/usr/bin/python
# -*- coding: Utf-8 -*-

# script de création du fichier *.pot dans locale/

import os

def fichiersModule(dossier, ligne):
	"""transforme une ligne __init__ en liste de fichiers (chemin est extension compris) à traduire"""
	
	d = 0	# drapeau: le caractère traité est au-delà de '['
	ch = '' # chaîne de caractère qui deviendra progressivement un nom du fichier (sans chemin ni '.py')
	tot=''	# ce que l'on retourne (voir doc initiale)
	
	for i in ligne: # i: un caractère de la ligne
		if i == '[':
			d = 1
		elif i == ']':
			tot = tot + dossier + '/' + ch + '.py'+ ' '
			break
		elif i in ["'",' ']:
			pass
		elif i == ',':
			tot = tot + dossier + '/' + ch + '.py' + ' '
			ch = ''
		elif d:
			ch = ch + i
	return tot

totalFichiersSource = ''

# liste des répertoires contenant les fichiers à traduire
listeModulesGui = 	['dependances','gui_modules_animation','gui_modules_image',
			'gui_modules_music_son','gui_modules_lecture', 'gui_modules_image/divers',
			'gui_modules_image/filtres_images', 'gui_modules_image/masque_alpha_3d',
			'gui_modules_image/transitions', 'gui_modules_sequentiel']

# construction de la chaîne de caractères contenant les fichiers à traduire (chemin est extension compris)
for i in listeModulesGui:
	ficOb = open(i+'/__init__.py','r')
	ligne = ficOb.readline()
	fichiersModulesGui = fichiersModule(i, ligne)
	totalFichiersSource = totalFichiersSource + fichiersModulesGui
	ficOb.close()

totalFichiersSource += 'ekd_gui.py'

print totalFichiersSource # test

# commande de création du fichier-source de traduction *.pot
os.system('xgettext -o locale/ekd.pot' + ' ' + totalFichiersSource)